{-# OPTIONS_GHC -fglasgow-exts -cpp -optP-P #-}
{-# LANGUAGE CPP #-}
-- #hide
{- |
   License      : BSD3
   Maintainer   : Takano Akio <aljee@hyper.cx>
   Stability    : experimental
   
   Debugging support.
-}
module System.IO.SSC.Internal.Debug where

import Control.Monad
import Data.IORef
import System.IO.Unsafe
import System.IO
# ifdef __GLASGOW_HASKELL__
import GHC.Prim
# endif

cnt :: IORef Int
cnt = unsafePerformIO $ newIORef 0

inc :: IO Int
inc = do
  modifyIORef cnt (+1)
  cur

cur :: IO Int
cur = readIORef cnt

cond :: (Int -> Bool) -> IO () -> IO ()
cond f a = do
  c <- cur
  when (f c) a

--msg = hPutStrLn stderr 
msg _ = return ()

# ifdef __GLASGOW_HASKELL__
coerce = unsafeCoerce#
# endif
